Attribute VB_Name = "modImportant"
Option Explicit

'==========================================================================================================================
'FLAP Header:
'   ["*"][channel][2 byte request ID][2 byte packet length]
'   Channels:
'       1 - connection
'       2 - data
'       3 - error
'       4 - disconnect
'       5 - keepalive
'
'Packet Structure:
'   [FLAP Header] [2 byte family] [2 byte subfamily] [2 byte SNAC flags (usually "00")] [4 byte SNAC ID] [optional TLVs and parameters]
'
'TLV Structure:
'   [0][TLV type][2 byte TLV length][TLV value (in ascii)]
'==========================================================================================================================

Public Function TLV(strTLV As String, Data As String) As String
'idk who wrote this
TLV = Chr$(0) & Chr$(strTLV) & Word(Len(Data)) & Data
End Function

Public Function ExtractTLV(Data As String, TLV As String) As String
'idk who wrote this, but i fixed it up
Dim strStartIt As String
Dim i As Integer
If InStr(1, Data, Chr$(TLV)) <> 0 Then
    For i = 1 To Len(Data)
        If Mid$(Data, i, 2) = Chr$(0) & Chr$(TLV) Then
            strStartIt = Mid$(Data, i)
            ExtractTLV = Mid$(strStartIt, 5, GetWord(Mid$(strStartIt, 3, 2)))
        End If
    Next i
Else
    'TLV not in data
End If
End Function

Public Function AuthLogin(strUser As String, strPassword As String) As String
'idk who wrote this, but i fixed it up
Dim strClientProfile As String, strVersionStart As String, strVersionMajor As String, strVersionMinor As String, strVersionBuild As String, strCountryCode As String, strLanguageCode As String, strDisconnectReason As String, strMultiConnectFlags As String
strClientProfile = TLV(3, "AOL Instant Messenger version 5.2.3074/WIN32")
strVersionStart = TLV(22, Chr$(0) & Chr$(1))
strVersionMajor = TLV(23, Chr$(0) & Chr$(5))
strVersionMinor = TLV(24, Chr$(0) & Chr$(1))
strVersionBuild = TLV(25, Chr$(9) & Chr$(236))
strCountryCode = TLV(14, "us")
strLanguageCode = TLV(15, "en")
strDisconnectReason = TLV(9, Chr$(0) & Chr$(9))
strMultiConnectFlags = TLV(74, Chr$(1)) 'supports multiple instances
AuthLogin = ChrA("0 0 0 1") & TLV(1, strUser) & TLV(2, EncryptPW(strPassword)) & strClientProfile & strVersionStart & strVersionMajor & strVersionMinor & strVersionBuild & strCountryCode & strLanguageCode & strDisconnectReason & strMultiConnectFlags
End Function

Public Function RequestRateInformation() As String
RequestRateInformation = ChrA("0 1 0 6 0 0 0 0 0 6")
End Function

Public Function RequestPersonalInfo() As String
RequestPersonalInfo = ChrA("0 1 0 14 0 0 0 0 0 14")
End Function

Public Function RequestRateAck() As String
'subscribe to rate class (doesn't work apparently)
'1 - packet sending
'2 - not used
'3 - not used
'4 - not used
'5 - message sending
RequestRateAck = ChrA("0 1 0 8 0 0 0 0 0 8 0 1 0 2 0 3 0 4 0 5")
End Function

Public Function RequestPrivacy() As String
RequestPrivacy = ChrA("0 1 0 20 0 0 0 0 0 20 0 0 0 3")
End Function

Public Function ClientReady() As String
ClientReady = ChrA("0 1 0 2 0 0 0 0 2 0 0 1 0 4 1 16 8 241 0 2 0 1 1 16 8 241 0 3 0 1 1 16 8 241 0 4 0 1 1 16 8 241 0 9 0 1 1 16 8 241 0 10 0 1 1 16 8 241")
End Function

Public Function ServChat() As String 'request chatnav server
ServChat = ChrA("0 1 0 4 0 0 0 0 0 4 0 13")
End Function

Public Function FormatLoginPacket() As String
'tells server which family versions client supports
'server sends back 1 x 24 telling client which family versions server supports
FormatLoginPacket = ChrA("0 1 0 23 0 0 0 0 0 23 0 1 0 4 0 19 0 5")
End Function

Public Function ChatNavReady() As String 'client ready for chat navigation server
ChatNavReady = ChrA("0 1 0 2 0 0 0 0 0 2 0 1 0 4 0 16 8 241 0 13 0 1 0 16 8 241")
End Function

Public Function ChatReady() As String 'client ready for chat server
ChatReady = ChrA("0 1 0 2 0 0 0 0 0 2 0 1 0 4 0 16 8 241 0 14 0 1 0 16 8 241")
End Function

Public Function ServChat2(Chatname As String, Exchange As Integer, Optional Instance As Integer = 0) As String 'request chat server
On Error Resume Next
Dim strChatURL As String
If Instance > 0 Then
    strChatURL = "!aol://2719:10-" & Exchange & "-" & Instance & "-" & Strip(Chatname)
Else
    strChatURL = "!aol://2719:10-" & Exchange & "-" & Strip(Chatname)
End If
ServChat2 = ChrA("0 1 0 4 0 0 0 0 0 4 0 14") & TLV(1, ChrA("0 4") & Chr$(Len(strChatURL)) & strChatURL & ChrA("0 0"))
End Function

Public Function ReqID2() As String 'generates a fake request ID
'idk who wrote this
Dim i As Integer
For i = 1 To 8
    ReqID2 = ReqID2 & Chr$(i + 200)
Next i
ReqID2 = ReqID2
End Function

Public Function Word(ByVal lngVal As Long) As String
'idk who wrote this
Dim Lo As Single
Dim Hi As Single
Lo = Fix(lngVal / 256)
Hi = lngVal - Lo * 256
Word = Chr$(Lo) & Chr$(Hi)
End Function

Public Function GetWord(ByVal strVal As String) As Long
'idk who wrote this
On Error Resume Next
Dim Lo As Long
Dim Hi As Long
Lo = Asc%(Mid$(strVal, 1, 1))
Hi = Asc%(Mid$(strVal, 2, 1))
GetWord = (Lo * 256) + Hi
End Function

Public Function DWord(ByVal lngVal As Double) As String
'idk who wrote this
On Error Resume Next
Dim Lo As Single
Dim Hi As Single
Lo = Fix(lngVal / 65536)
Hi = lngVal - 65536 * Int(lngVal / 65536)
DWord = Word(Lo) & Word(Hi)
End Function

Public Function GetDWord(ByVal strVal As String) As Double
'idk who wrote this
On Error Resume Next
Dim LoWord As Single
Dim HiWord As Single
LoWord = GetWord(Mid$(strVal, 1, 2))
HiWord = GetWord(Mid$(strVal, 3, 2))
GetDWord = (LoWord * 65536) + HiWord
End Function

Public Function ChrA(ByRef stuff As String) As String
'rewritten by me
Dim chars() As String, i As Integer
chars() = Split(stuff, " ")
For i = 0 To UBound(chars())
     ChrA = ChrA & Chr$(chars(i))
Next i
End Function

Public Function AscA(ByRef stuff As String) As String
On Error Resume Next
Dim i As Integer
For i = 0 To Len(stuff)
     AscA = AscA & " " & Asc%(Mid$(stuff, i, 1))
Next i
End Function

Public Function EncryptPW(ByRef strPass As String) As String
'idk who wrote this
Dim arrTable() As Variant
Dim strEncrypted As String
Dim lngX As Long
Dim strHex As String
arrTable = Array(243, 179, 108, 153, 149, 63, 172, 182, 197, 250, 107, 99, 105, 108, 195, 154)
For lngX = 0 To Len(strPass$) - 1
    strHex = Chr$(Asc%(Mid$(strPass, lngX + 1, 1)) Xor CLng(arrTable((lngX Mod 16))))
    strEncrypted = strEncrypted & strHex
Next
EncryptPW = strEncrypted
End Function
