Attribute VB_Name = "modImportant"
Option Explicit

'==========================================================================================================================
'FLAP Header:
'   ["*"][channel][2 byte request ID][2 byte packet length]
'   Channels:
'       1 - connection
'       2 - data
'       3 - error
'       4 - disconnect
'       5 - keepalive
'
'Packet Structure:
'   [FLAP Header] [2 byte family] [2 byte subfamily] [2 byte SNAC flags (usually "00")] [4 byte SNAC ID] [optional TLVs and parameters]
'
'TLV Structure:
'   [0][TLV type][2 byte TLV length][TLV value (in ascii)]
'==========================================================================================================================

Public Function TLV(strTLV As String, Data As String) As String
'idk who wrote this
TLV = Chr$(0) & Chr$(strTLV) & Word(Len(Data)) & Data
End Function

Public Function ConvertTime(Weeks As String, Days As String, Hours As String, Minutes As String) As Long

    If Weeks <> vbNullString Then
    
        ConvertTime& = CLng(Weeks) * 7 * 24 * 60 * 60
        
    End If
    
    If Days <> vbNullString Then
    
        ConvertTime& = CLng(Days) * 24 * 60 * 60
        
    End If
    
    If Hours <> vbNullString Then
    
        ConvertTime& = CLng(Hours) * 60 * 60
        
    End If
    
    If Minutes <> vbNullString Then
    
        ConvertTime& = CLng(Minutes) * 60
        
    End If

End Function

Public Function ExtractTLV(Data As String, TLV As String) As String
'idk who wrote this, but i fixed it up
Dim strStartIt As String
Dim i As Integer
If InStr(1, Data, Chr$(TLV)) <> 0 Then
    For i = 1 To Len(Data)
        If Mid$(Data, i, 2) = Chr$(0) & Chr$(TLV) Then
            strStartIt = Mid$(Data, i)
            ExtractTLV = Mid$(strStartIt, 5, GetWord(Mid$(strStartIt, 3, 2)))
        End If
    Next i
Else
    'TLV not in data
End If
End Function

Public Function AuthLogin(strUser As String, strPassword As String) As String
'idk who wrote this, but i fixed it up
Dim strClientProfile As String, strVersionStart As String, strVersionMajor As String, strVersionMinor As String, strVersionBuild As String, strCountryCode As String, strLanguageCode As String, strDisconnectReason As String, strMultiConnectFlags As String
strClientProfile = TLV(3, "AOL Instant Messenger version 5.9.6089/WIN32")
strVersionStart = TLV(22, Chr$(0) & Chr$(1))
strVersionMajor = TLV(23, Chr$(0) & Chr$(5))
strVersionMinor = TLV(24, Chr$(0) & Chr$(1))
strVersionBuild = TLV(25, Chr$(9) & Chr$(236))
strCountryCode = TLV(14, "us")
strLanguageCode = TLV(15, "en")
strDisconnectReason = TLV(9, Chr$(0) & Chr$(9))
strMultiConnectFlags = TLV(74, Chr$(1)) 'supports multiple instances
AuthLogin = ChrA("0 0 0 1") & TLV(1, strUser) & TLV(2, EncryptPW(strPassword)) & strClientProfile & strVersionStart & strVersionMajor & strVersionMinor & strVersionBuild & strCountryCode & strLanguageCode & strDisconnectReason & strMultiConnectFlags
End Function

Public Function RequestRateInformation() As String
RequestRateInformation = ChrA("0 1 0 6 0 0 0 0 0 6")
End Function

Public Function RequestPersonalInfo() As String
RequestPersonalInfo = ChrA("0 1 0 14 0 0 0 0 0 14")
End Function

Public Function RequestRateAck() As String
'subscribe to rate class (doesn't work apparently)
'1 - packet sending
'2 - not used
'3 - not used
'4 - not used
'5 - message sending
RequestRateAck = ChrA("0 1 0 8 0 0 0 0 0 8 0 1 0 2 0 3 0 4 0 5")
End Function

Public Function RequestPrivacy() As String
RequestPrivacy = ChrA("0 1 0 20 0 0 0 0 0 20 0 0 0 3")
End Function

Public Function ClientReady() As String
ClientReady = ChrA("0 1 0 2 0 0 0 0 2 0 0 1 0 4 1 16 8 241 0 2 0 1 1 16 8 241 0 3 0 1 1 16 8 241 0 4 0 1 1 16 8 241 0 9 0 1 1 16 8 241 0 10 0 1 1 16 8 241")
End Function

Public Function ServChat() As String 'request chatnav server
ServChat = ChrA("0 1 0 4 0 0 0 0 0 4 0 13")
End Function

Public Function FormatLoginPacket() As String
'tells server which family versions client supports
'server sends back 1 x 24 telling client which family versions server supports
FormatLoginPacket = ChrA("0 1 0 23 0 0 0 0 0 23 0 1 0 4 0 19 0 5")
End Function

Public Function ChatNavReady() As String 'client ready for chat navigation server
ChatNavReady = ChrA("0 1 0 2 0 0 0 0 0 2 0 1 0 4 0 16 8 241 0 13 0 1 0 16 8 241")
End Function

Public Function ChatReady() As String 'client ready for chat server
ChatReady = ChrA("0 1 0 2 0 0 0 0 0 2 0 1 0 4 0 16 8 241 0 14 0 1 0 16 8 241")
End Function

Public Function ChatReady2() As String 'client ready for chat server
ChatReady2 = ChrA("0 1 0 2 0 0 0 0 0 2")
End Function

Public Function ServChat2(ChatName As String, Exchange As Integer, Optional Instance As Integer = 0) As String 'request chat server
On Error Resume Next
Dim strChatURL As String
If Instance > 0 Then
    strChatURL = "!aol://2719:10-" & Exchange & "-" & Instance & "-" & Strip(ChatName)
Else
    strChatURL = "!aol://2719:10-" & Exchange & "-" & Strip(ChatName)
End If
ServChat2 = ChrA("0 1 0 4 0 0 0 0 0 4 0 14") & TLV(1, ChrA("0 4") & Chr$(Len(strChatURL)) & strChatURL & ChrA("0 0"))
End Function

Public Function GrabTLV2(ByVal TLV_Number As Integer, ByVal strData As String) As String

    Dim Stuff(0 To 2) As String, i As Integer
        
    For i% = 17 To Len(strData$) - 3

        If Mid$(strData$, i%, 1) = Chr$(0) And Mid$(strData$, i% + 1, 1) <> Chr$(0) And Mid$(strData$, i% + 2, 1) = Chr$(0) And Mid$(strData$, i% + 3, 1) <> Chr$(0) Then
    
            Stuff$(0) = Asc%(Mid$(strData$, i% + 1, 1))
    
            Stuff$(1) = Asc%(Mid$(strData$, i% + 3, 1))
    
            If (Stuff$(1) + i% + 3) <= Len(strData$) Then
        
                Stuff$(2) = Mid$(strData$, i% + 4, Stuff$(1))
        
                Select Case Stuff$(0)

                    Case TLV_Number%
                        
                        GrabTLV2 = Replace(Stuff$(2), Chr$(0), Chr$(1))
                        
                        Exit Function

                End Select
        
            End If

        End If

        DoEvents
        
    Next i%

End Function

Public Function Set_Super_Capabilities()
    
    'How manycaps are there? I know of atleast 10. Know of one I didn't add? Tell me :-D, thanks!
    'It goes
    'Voice
    'File Send
    'Image/Direct IM
    'Buddy Icon
    'Addons
    'Get file
    'Games
    'Unknown? Someone know? Tell me pelase!
    'Send Buddylist
    'Chat
    'AIM/ICQ
    'Short caps
    'Smart CAPS
    'Camera
    'Secure IM
    'XHTML
    'RTC_Video
    'Has mic phone
    'RTC Audio
    'New Status MSG
    'See as I type
    'Direct play
    'Route finder
    'Extra TLV
    'Accept UTF
    'Mail
    'Mail 2
    'News
    'Stocks
    'Weather
    'Dracula
    'YGP
    'Third party
    'Net2Phone
    'Reminders
    'Rendered
    'FF News
    'FF Sports
    'Feedbag buddy
    'Feedbag Group
    'Feedbag stock
    'Feedbag weather
    'ICQ 1st
    'ICQ Last
    'Apple first
    'Apple last
    'MOTW
    'Imap4
    'SMTP
    'Addr Book
    'IMAP4 AOL
    'SMTP AOL
    'Addrbook AOL
    'Magic Carpet
    
    Set_Super_Capabilities = CAPIT("09461341-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461343-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461345-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461346-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461347-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461348-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946134a-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460105-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946134B-4C7F-11D1-8222-444553540000") & _
                             CAPIT("748F2420-6287-11D1-8222-444553540000") & _
                             CAPIT("0946134D-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460000-4C7F-11D1-8222-444553540000") & _
                             CAPIT("094601FF-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460102-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460001-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460002-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460101-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460103-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09460104-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946010A-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946010B-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461342-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461344-4C7F-11D1-8222-444553540000") & _
                             CAPIT("09461349-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946134E-4C7F-11D1-8222-444553540000")
                             
    Set_Super_Capabilities = Set_Super_Capabilities & _
                             CAPIT("5D5E1708-55AA-11D3-B143-0060B0FB1ECB") & _
                             CAPIT("84350CC8-E401-11D5-9754-0060B0EE0631") & _
                             CAPIT("5D5E1709-55AA-11D3-B143-0060B0FB1ECB") & _
                             CAPIT("5D5E170A-55AA-11D3-B143-0060B0FB1ECB") & _
                             CAPIT("5D5E170E-55AA-11D3-B143-0060B0FB1ECB") & _
                             CAPIT("78382132-8E20-11D3-9830-8F6ED783EDD8") & _
                             CAPIT("58CF279A-9911-11D3-A159-D57FA28A7112") & _
                             CAPIT("9269D81C-A6A2-11D3-AEE2-E2489E91D6E7") & _
                             CAPIT("33DD2CBA-0FDC-11D4-B073-BC1838CEF8C8") & _
                             CAPIT("3B4056D2-7457-11D4-A1D5-DC243835AD24") & _
                             CAPIT("B3809AD8-0DBA-11D5-9F8A-0060B0EE0631") & _
                             CAPIT("3DFA0724-2AD7-11D5-9773-0060B0EE0631") & _
                             CAPIT("67400b76-3516-11d5-8b6c-0060b0ee0631") & _
                             CAPIT("200A0000-A289-11D3-A52D-001083341CFA") & _
                             CAPIT("200A0001-A289-11D3-A52D-001083341CFA") & _
                             CAPIT("200A000A-A289-11D3-A52D-001083341CFA") & _
                             CAPIT("200A000B-A289-11D3-A52D-001083341CFA") & _
                             CAPIT("0946E000-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946E0FF-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946F000-4C7F-11D1-8222-444553540000") & _
                             CAPIT("0946F00F-4C7F-11D1-8222-444553540000") & _
                             CAPIT("7f53f598-05aa-11d4-a5ad-001083341cfa") & _
                             CAPIT("3e8001da-de70-11d3-a57d-001083341cfa") & _
                             CAPIT("3e8001db-de70-11d3-a57d-001083341cfa")
                             
    Set_Super_Capabilities = Set_Super_Capabilities & _
                             CAPIT("3ff9b60d-c55b-4d4f-b9d0-ca6a0f5783be") & _
                             CAPIT("50000000-2a9a-11d5-808a-0060b0ee0631") & _
                             CAPIT("50000001-2a9a-11d5-808a-0060b0ee0631") & _
                             CAPIT("50000002-2a9a-11d5-808a-0060b0ee0631") & _
                             CAPIT("c28e07ec-4486-11d5-9673-0060b0ee0631")

End Function

Public Function CAPIT(ByRef strStrin)

'Got from Robbie Saunders
    
    Dim strGay, i As Integer
    strStrin = Replace(strStrin, "-", "")
    strGay = ""
    For i = 0 To (Len(strStrin) / 2) - 1
        strGay = strGay & Chr$("&H" & Mid$(strStrin, (i * 2) + 1, 2))
        DoEvents
    Next i
    CAPIT = strGay

End Function

Public Function ReqID2() As String 'generates a fake request ID
'idk who wrote this
Dim i As Integer
For i = 1 To 8
    ReqID2 = ReqID2 & Chr$(i + 200)
Next i
ReqID2 = ReqID2
End Function

Public Function Word(ByVal lngVal As Long) As String
'idk who wrote this
Dim Lo As Single
Dim Hi As Single
Lo = Fix(lngVal / 256)
Hi = lngVal - Lo * 256
Word = Chr$(Lo) & Chr$(Hi)
End Function

Public Function GetWord(ByVal strVal As String) As Long
'idk who wrote this
On Error Resume Next
Dim Lo As Long
Dim Hi As Long
Lo = Asc%(Mid$(strVal, 1, 1))
Hi = Asc%(Mid$(strVal, 2, 1))
GetWord = (Lo * 256) + Hi
End Function

Public Function DWord(ByVal lngVal As Double) As String
'idk who wrote this
On Error Resume Next
Dim Lo As Single
Dim Hi As Single
Lo = Fix(lngVal / 65536)
Hi = lngVal - 65536 * Int(lngVal / 65536)
DWord = Word(Lo) & Word(Hi)
End Function

Function GetLength(ByteLength As String) As Long

If Len(ByteLength) >= 3 Then
    
    GetLength = (Asc%(Mid$(ByteLength, 1, 1)) * 256 * 256) + (Asc%(Mid$(ByteLength, 2, 1)) * 256) + (Asc%(Mid$(ByteLength, 3, 1)) * 1)

End If

End Function

Public Function GetDWord(ByVal strVal As String) As Double
'idk who wrote this
On Error Resume Next
Dim LoWord As Single
Dim HiWord As Single
LoWord = GetWord(Mid$(strVal, 1, 2))
HiWord = GetWord(Mid$(strVal, 3, 2))
GetDWord = (LoWord * 65536) + HiWord
End Function

Public Function ChrA(ByRef Stuff As String) As String
'rewritten by me
Dim Chars() As String, i As Integer
Chars() = Split(Stuff, " ")
For i = 0 To UBound(Chars())
     ChrA = ChrA & Chr$(Chars(i))
Next i
End Function

Public Function AscA(ByRef Stuff As String) As String
On Error Resume Next
Dim i As Integer
For i = 0 To Len(Stuff)
     AscA = AscA & " " & Asc%(Mid$(Stuff, i, 1))
Next i
End Function

Public Function EncryptPW(ByRef strPass As String) As String
'idk who wrote this
Dim arrTable() As Variant
Dim strEncrypted As String
Dim lngX As Long
Dim strHex As String
arrTable = Array(243, 179, 108, 153, 149, 63, 172, 182, 197, 250, 107, 99, 105, 108, 195, 154)
For lngX = 0 To Len(strPass$) - 1
    strHex = Chr$(Asc%(Mid$(strPass, lngX + 1, 1)) Xor CLng(arrTable((lngX Mod 16))))
    strEncrypted = strEncrypted & strHex
Next
EncryptPW = strEncrypted
End Function
