Attribute VB_Name = "modAOLData"
Option Explicit

'Nick Information User Classes
Public Const NICK_FLAG_DAMNED_TRANSIENT           As Long = &H1
Public Const NICK_FLAG_ADMINISTRATOR              As Long = &H2
Public Const NICK_FLAG_AOL                        As Long = &H4
Public Const NICK_FLAG_OSCAR_PAY                  As Long = &H8
Public Const NICK_FLAG_OSCAR_FREE                 As Long = &H10
Public Const NICK_FLAG_UNAVAILABLE                As Long = &H20
Public Const NICK_FLAG_ICQ                        As Long = &H40
Public Const NICK_FLAG_WIRELESS                   As Long = &H80
Public Const NICK_FLAG_INTERNAL                   As Long = &H100
Public Const NICK_FLAG_FISH                       As Long = &H200
Public Const NICK_FLAG_BOT                        As Long = &H400
Public Const NICK_FLAG_BEAST                      As Long = &H800

Public Function DeHex(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double
    
    For iCount = 1 To Len(Data) Step 2
        DeHex = DeHex & Chr$(Val("&H" & Mid$(Data, iCount, 2)))
    Next iCount

End Function

Public Function EnHex(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double
    Dim sTemp As String
    
    For iCount = 1 To Len(Data)
        sTemp = Hex$(Asc(Mid$(Data, iCount, 1)))
        If Len(sTemp) < 2 Then sTemp = "0" & sTemp
        EnHex = EnHex & sTemp
    Next iCount

End Function

Public Function Hex2Int(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double

    For iCount = 1 To Len(Data) Step 2
        Hex2Int = Hex2Int & CInt(Val("&H" & Mid$(Data, iCount, 2)))
    Next iCount

End Function

Public Function Int2Hex(Data As String) As String

    On Error Resume Next
    
    Dim sTemp As String

    sTemp = Hex(Data)
    If Len(sTemp) < 2 Then sTemp = "0" & sTemp
    Int2Hex = Int2Hex & sTemp

End Function

Public Function GenRanNum(HighestNum As Long, LowestNum As Long)

    Randomize
    GenRanNum = Int((HighestNum - LowestNum + 1) * Rnd + LowestNum)
    
End Function

Public Function IntegerToBase256(Value As Integer) As String

    IntegerToBase256 = Chr(Int(Value / 256)) & Chr(Value - (Int(Value / 256)) * 256)
    
End Function

Public Function LngToBase256(Value As Long) As String

    LngToBase256 = Chr(Int(Value / 256)) & Chr(Value - (Int(Value / 256)) * 256)
    
End Function

Public Function Hex2LngVar(Data As String, StepLength As Integer) As String

    On Error GoTo Hex2LngVarErr
    Dim iCount As Double
    
    For iCount = 1 To Len(Data) Step StepLength
    
    Hex2LngVar = Hex2LngVar & CLng("&H" & Mid$(Data, iCount, StepLength))
    
    Next iCount
    Exit Function
    
Hex2LngVarErr:
    Hex2LngVar = "Error"
    
End Function

Public Function ShiftRight(ByVal Value As Long, ByVal Bits As Integer) As Long
    
    ShiftRight = Value \ 2 ^ Bits

End Function

